# helper routines for authentication stuff
# (c) 2004 Andreas Krennmair
# $Id: auth.rb,v 1.3 2004/03/27 18:11:31 ak Exp $

$xx_session_key = "golbikiw_sid"
$xx_prefix = "golbikiw-session."

def generate_sid
  x = ((rand*100000).to_i ^ (rand*50000).to_i).to_s + ((rand*10000).to_i | (rand*5000).to_i).to_s
  return x
end

def username_fits_password(username,password)
  begin
    f = File.new("conf/users.txt")
    f.each_line do |l|
      l.chomp!
      if l[0..0] != "!" then
        x = l.split(":")
        if (x[0].to_s == username.to_s) and (x[1].to_s == password.to_s) then
          return true
        end
      end
    end
  rescue
    return false
  end
  return false
end

def do_authenticate(user)
  sid = generate_sid
  sess = CGI::Session.new($cgi, "session_key" => $xx_session_key, "session_id" => sid, "prefix" => $xx_prefix, "new_session" => true )
  sess["authenticated"] = "yes"
  sess["username"] = user
  sess.update
end

def get_username
  sess = CGI::Session.new($cgi, "session_key" => $xx_session_key, "prefix" => $xx_prefix)
  if sess then
    return sess["username"]
  end
  return ""
end

def is_authenticated?
  sess = CGI::Session.new($cgi, "session_key" => $xx_session_key, "prefix" => $xx_prefix)
  if sess then
    #$stderr.puts "sess is defined"
    if sess["authenticated"] == "yes" then
      #$stderr.puts "authenticated"
      true
    else
      #$stderr.puts "not authenticated"
      false
    end
  end
end

def do_logout
  sess = CGI::Session.new($cgi, "session_key" => $xx_session_key, "prefix" => $xx_prefix)
  if sess then
    sess.delete
  end
end
